package net.lensfrex.socket.common;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;

public class Common {
    public static DataPack readDataPack(InputStream inputStream) {
        return readDataPack(Util.readAllData(inputStream));
    }

    public static DataPack readDataPack(byte[] dataPackBytes) {
        return DataPack.parse(dataPackBytes);
    }

    public static int sendMessage(String id, String message, OutputStream outputStream) throws IOException {
        MessageData messageData = new MessageData(id, message);

        return sendMessage(messageData, outputStream);
    }

    public static int sendMessage(MessageData message, OutputStream outputStream) throws IOException {
        return sendMessage(message.toBytes(), outputStream);
    }

    public static int sendMessage(byte[] data, OutputStream outputStream) throws IOException {
        return send(data, Constant.OPCODE_SEND_MESSAGE, outputStream);
    }

    public static int send(byte[] data, byte[] opcode, OutputStream outputStream) throws IOException {
        DataPack dataPack = new DataPack(opcode, data);

        return send(dataPack, outputStream);
    }

    public static int send(DataPack dataPack, OutputStream outputStream) throws IOException {
        outputStream.write(Constant.MAGIC_HEADER);
        outputStream.write(dataPack.toBytes());

        outputStream.flush();
        return dataPack.getDataLength();
    }
}
